/*******************************************************************************
 * FoxDialogBoxMessageMissionComplete generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDialogBoxMessageMissionComplete extends FoxDialogBoxMessageBase within FoxUI
    native(UI)
    config(UI);

struct native MissionCompleteDialogBoxProperties
{
    var init array<init MissionMetaData> MissionItems;
    var delegate<PostReadMessage> OnReadMessageComplete;

    structdefaultproperties
    {
        MissionItems=none
        ReadMessa=None
    }
};

var protected transient MissionCompleteDialogBoxProperties CurrentProperties;
var private int NextMissionIndex;
var private transient bool bIsClearing;
var private transient FoxUIItemTileWidget ItemTileWidget;
var const localized string TitleLabel;
var const localized string SeperatorLabel;

function ShowDialog(const MissionCompleteDialogBoxProperties Properties)
{
    CurrentProperties = Properties;
    NextMissionIndex = 0;
    //return;    
}

function CloseDialog()
{
    local FoxItemCacheHistory HistoryCache;
    local FoxItemCacheInventory InventoryCache;
    local FoxServerConnection ServerConn;
    local array<string> MergeKeys;
    local int I, CurrentIndex;

    CurrentIndex = NextMissionIndex - 1;
    // End:0x4F
    if(ItemTileWidget != none)
    {
        ItemTileWidget.Cleanup();
        ItemTileWidget = none;
    }
    I = 0;
    J0x5A:
    // End:0xC5 [Loop If]
    if(I <= CurrentIndex)
    {
        MergeKeys.AddItem(CurrentProperties.MissionItems[I].Key);
        ++ I;
        // [Loop Continue]
        goto J0x5A;
    }
    // End:0x12B
    if((MergeKeys.Length > 0) && class'FoxDataStore_StoreData'.static.GetCachedHistory(HistoryCache))
    {
        HistoryCache.MergeHistoryUpdates(,, MergeKeys);
    }
    // End:0x1FF
    if(class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache))
    {
        InventoryCache.MergeUpdatedItems();
        ServerConn = FoxServerConnection(Outer.PCOwner.WorldInfo.ServerConn);
        // End:0x1FF
        if(ServerConn != none)
        {
            ServerConn.ApplyInventoryFromCache();
        }
    }
    super(FoxDialogBoxBase).CloseDialog();
    //return;    
}

private final function addDialogContent()
{
    bIsClearing = false;
    //return;    
}

protected function ei_acceptButtonPressed()
{
    ++ NextMissionIndex;
    // End:0x39
    if(NextMissionIndex < CurrentProperties.MissionItems.Length)
    {
    }
    // End:0x4F
    else
    {
        CloseDialog();
        NotifyButtonPressed(0);
    }
    //return;    
}

protected function ei_cancelButtonPressed()
{
    NextMissionIndex = CurrentProperties.MissionItems.Length;
    CloseDialog();
    NotifyButtonPressed(1);
    //return;    
}

private final function ei_selectAttachedItem(string OfferGuid)
{
    //return;    
}

private final function as_clearDialog()
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x5B
    if(BoundObject != none)
    {
        bIsClearing = true;
        BoundObject.ActionScriptVoid("clearDialog");
    }
    //return;    
}

protected function as_updateMissionDialogBoxItem(const MissionItemEntry ItemEntry)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x57
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("updateDialogBoxItem");
    }
    //return;    
}

defaultproperties
{
    TitleLabel="MISSION COMPLETE"
    SeperatorLabel="OF"
    LocAcceptLabel="NEXT"
    LocCancelLabel="CLOSE"
}